Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3550)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3551)
@@ -2049,6 +2111,88 @@
                                                            )
        ENDDO
-
-       DO  k = nzb+1, nzb_max
+       
+       DO  k = nzb+3, nzt-2
+
+          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
+
+          w_comp(k) = w(k,j,i) + w(k,j,i-1)
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)  + u(k,j,i)     )                &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k+2,j,i) + u(k-1,j,i)   )                 &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k+3,j,i) + u(k-2,j,i) )                   &
+                                                  )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k+2,j,i)  - u(k-1,j,i)  )                 &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k+3,j,i) - u(k-2,j,i) )                   &
+                                                           )
+       ENDDO
+       
+       DO  k = nzt-1, nzt
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit17
+          k_pp  = k + 2 * ( 1 - ibit15 )
+          k_mm  = k - 2 * ibit17
+
+          w_comp(k) = w(k,j,i) + w(k,j,i-1)
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)  + u(k,j,i)     )                &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
+                                                  )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
+                                                           )
+       ENDDO
+       
+       DO  k = nzb+1, nzt
 
           flux_d    = flux_t(k-1)
@@ -2057,30 +2201,32 @@
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography. 
+!--       by a not sufficient reduction of divergences near topography.
           div = ( ( u_comp(k)       * ( ibit9 + ibit10 + ibit11 )             &
                 - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * ( IBITS(advc_flags_1(k,j,i-1),9,1)      &
-                                      + IBITS(advc_flags_1(k,j,i-1),10,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),11,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )     &
                                       )                                       &
                   ) * ddx                                                     &
                +  ( ( v_comp(k) + gv ) * ( ibit12 + ibit13 + ibit14 )         &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * ( IBITS(advc_flags_1(k,j-1,i),12,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),13,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),14,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )     &
                                       )                                       &
                   ) * ddy                                                     &
                +  ( w_comp(k)   * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )&
                 -   w_comp(k-1) * rho_air_zw(k-1)                             &
-                                    * ( IBITS(advc_flags_1(k-1,j,i),15,1)     &
-                                      + IBITS(advc_flags_1(k-1,j,i),16,1)     &
-                                      + IBITS(advc_flags_1(k-1,j,i),17,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k-1,j,i),15,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k-1,j,i),16,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k-1,j,i),17,1), KIND = wp )     &
                                       )                                       &  
                   ) * drho_air(k) * ddzw(k)                                   &
                 ) * 0.5_wp
 
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
+           tend(k,j,i) = tend(k,j,i) - (                                      &
                             ( flux_r(k) + diss_r(k)                           &
                           -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx     &
@@ -2088,5 +2234,5 @@
                           -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
                           + ( ( flux_t(k) + diss_t(k) )                       &
-                          -   ( flux_d    + diss_d )                          &
+                          -   ( flux_d    + diss_d    )                       &
                                                     ) * drho_air(k) * ddzw(k) &
                                        ) + div * u(k,j,i)
@@ -2111,121 +2257,4 @@
            sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                         &
                 + ( flux_t(k)                                                  &
-                    * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                )     &
-                    / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )        )     &
-                  + diss_t(k)                                                  &
-                    *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)           )     &
-                    / ( ABS( w_comp(k) ) + 1.0E-20_wp                    )     &
-                  ) *   weight_substep(intermediate_timestep_count)
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          u_comp(k) = u(k,j,i+1) + u(k,j,i)
-          flux_r(k) = ( u_comp(k) - gu ) * (                                  &
-                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                &
-                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                &
-                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-          diss_r(k) = - ABS( u_comp(k) - gu ) * (                             &
-                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                &
-                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                &
-                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
-
-          v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                &
-                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                &
-                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                &
-                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                &
-                       +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
-!
-!--       k index has to be modified near bottom and top, else array
-!--       subscripts will be exceeded.
-          ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
-          ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
-          ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
-
-          k_ppp = k + 3 * ibit17
-          k_pp  = k + 2 * ( 1 - ibit15 )
-          k_mm  = k - 2 * ibit17
-
-          w_comp(k) = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit17 * adv_mom_5                           &
-                  +     7.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)  + u(k,j,i)     )                &
-              -      (  8.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
-                                                  )
-
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit17 * adv_mom_5                           &
-                  +     3.0_wp * ibit16 * adv_mom_3                           &
-                  +              ibit15 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( u(k+1,j,i)   - u(k,j,i)    )                &
-              -      (  5.0_wp * ibit17 * adv_mom_5                           &
-                  +              ibit16 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
-              +      (           ibit17 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
-                                                           )
-
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
-!
-!--       Calculate the divergence of the velocity field. A respective
-!--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k)      - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx    &
-               +  ( v_comp(k) + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy    &
-               +  ( w_comp(k)   * rho_air_zw(k)   -                           &
-                    w_comp(k-1) * rho_air_zw(k-1)                             &
-                  ) * drho_air(k) * ddzw(k)                                   &
-                ) * 0.5_wp
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                            ( flux_r(k) + diss_r(k)                           &
-                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx     &
-                          + ( flux_n(k) + diss_n(k)                           &
-                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
-                          + ( ( flux_t(k) + diss_t(k) )                       &
-                          -   ( flux_d    + diss_d    )                       &
-                                                    ) * drho_air(k) * ddzw(k) &
-                                       ) + div * u(k,j,i)
-
-           flux_l_u(k,j,tn) = flux_r(k)
-           diss_l_u(k,j,tn) = diss_r(k)
-           flux_s_u(k,tn)   = flux_n(k)
-           diss_s_u(k,tn)   = diss_n(k)
-!
-!--        Statistical Evaluation of u'u'. The factor has to be applied for
-!--        right evaluation when gallilei_trans = .T. .
-           sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                           &
-                + ( flux_r(k)                                                  &
-                    * ( u_comp(k) - 2.0_wp * hom(k,1,1,0)                   )  &
-                    / ( u_comp(k) - gu + SIGN( 1.0E-20_wp, u_comp(k) - gu ) )  &
-                  + diss_r(k)                                                  &
-                    *   ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0)              )  &
-                    / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp                  )  &
-                  ) *   weight_substep(intermediate_timestep_count)
-!
-!--        Statistical Evaluation of w'u'.
-           sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                         &
-                + ( flux_t(k)                                                  &
                     * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   )  &
                     / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           )  &
@@ -2272,13 +2301,4 @@
 
        INTEGER(iwp)  ::  i      !< grid index along x-direction
-       INTEGER(iwp)  ::  ibit18 !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp)  ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp)  ::  ibit20 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp)  ::  ibit21 !< flag indicating 1st-order scheme along y-direction 
-       INTEGER(iwp)  ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp)  ::  ibit23 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp)  ::  ibit24 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp)  ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp)  ::  ibit26 !< flag indicating 3rd-order scheme along z-direction
        INTEGER(iwp)  ::  i_omp  !< leftmost index on subdomain, or in case of OpenMP, on thread
        INTEGER(iwp)  ::  j      !< grid index along y-direction
@@ -2289,10 +2309,19 @@
        INTEGER(iwp)  ::  tn     !< number of OpenMP thread
        
-       REAL(wp)     ::  diss_d   !< artificial dissipation term at grid box bottom
-       REAL(wp)     ::  div      !< divergence on v-grid
-       REAL(wp)     ::  flux_d   !< 6th-order flux at grid box bottom
-       REAL(wp)     ::  gu       !< Galilei-transformation velocity along x
-       REAL(wp)     ::  gv       !< Galilei-transformation velocity along y
-       REAL(wp)     ::  v_comp_l !< advection velocity along y on leftmost grid point on subdomain
+       REAL(wp)      ::  ibit18   !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)      ::  ibit19   !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)      ::  ibit20   !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)      ::  ibit21   !< flag indicating 1st-order scheme along y-direction 
+       REAL(wp)      ::  ibit22   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)      ::  ibit23   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)      ::  ibit24   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)      ::  ibit25   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)      ::  ibit26   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)      ::  diss_d   !< artificial dissipation term at grid box bottom
+       REAL(wp)      ::  div      !< divergence on v-grid
+       REAL(wp)      ::  flux_d   !< 6th-order flux at grid box bottom
+       REAL(wp)      ::  gu       !< Galilei-transformation velocity along x
+       REAL(wp)      ::  gv       !< Galilei-transformation velocity along y
+       REAL(wp)      ::  v_comp_l !< advection velocity along y on leftmost grid point on subdomain
        
        REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
@@ -2315,7 +2344,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit20 = IBITS(advc_flags_1(k,j,i-1),20,1)
-             ibit19 = IBITS(advc_flags_1(k,j,i-1),19,1)
-             ibit18 = IBITS(advc_flags_1(k,j,i-1),18,1)
+             ibit20 = REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )
+             ibit19 = REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )
+             ibit18 = REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )
 
              u_comp(k)        = u(k,j-1,i) + u(k,j,i) - gu
@@ -2373,7 +2402,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit23 = IBITS(advc_flags_1(k,j-1,i),23,1)
-             ibit22 = IBITS(advc_flags_1(k,j-1,i),22,1)
-             ibit21 = IBITS(advc_flags_1(k,j-1,i),21,1)
+             ibit23 = REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )
+             ibit22 = REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )
+             ibit21 = REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )
 
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
@@ -2425,8 +2454,4 @@
           
        ENDIF
-
-       flux_t(0) = 0.0_wp
-       diss_t(0) = 0.0_wp
-       w_comp(0) = 0.0_wp
 !
 !--    Now compute the fluxes and tendency terms for the horizontal and
@@ -2434,7 +2459,7 @@
        DO  k = nzb+1, nzb_max
 
-          ibit20 = IBITS(advc_flags_1(k,j,i),20,1)
-          ibit19 = IBITS(advc_flags_1(k,j,i),19,1)
-          ibit18 = IBITS(advc_flags_1(k,j,i),18,1)
+          ibit20 = REAL( IBITS(advc_flags_1(k,j,i),20,1), KIND = wp )
+          ibit19 = REAL( IBITS(advc_flags_1(k,j,i),19,1), KIND = wp )
+          ibit18 = REAL( IBITS(advc_flags_1(k,j,i),18,1), KIND = wp )
  
           u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
@@ -2469,7 +2494,7 @@
                                            )
 
-          ibit23 = IBITS(advc_flags_1(k,j,i),23,1)
-          ibit22 = IBITS(advc_flags_1(k,j,i),22,1)
-          ibit21 = IBITS(advc_flags_1(k,j,i),21,1)
+          ibit23 = REAL( IBITS(advc_flags_1(k,j,i),23,1), KIND = wp )
+          ibit22 = REAL( IBITS(advc_flags_1(k,j,i),22,1), KIND = wp )
+          ibit21 = REAL( IBITS(advc_flags_1(k,j,i),21,1), KIND = wp )
 
 
@@ -2504,10 +2529,51 @@
                                     ( v(k,j+3,i) - v(k,j-2,i) )               &
                                                 )
+       ENDDO
+
+       DO  k = nzb_max+1, nzt
+
+          u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp(k) * (                                           &
+                      37.0_wp * ( v(k,j,i+1) + v(k,j,i)   )                   &
+                    -  8.0_wp * ( v(k,j,i+2) + v(k,j,i-1) )                   &
+                    +           ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
+
+          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
+                      10.0_wp * ( v(k,j,i+1) - v(k,j,i) )                     &
+                    -  5.0_wp * ( v(k,j,i+2) - v(k,j,i-1) )                   &
+                    +           ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
+
+
+          v_comp(k) = v(k,j+1,i) + v(k,j,i)
+          flux_n(k) = ( v_comp(k) - gv ) * (                                  &
+                      37.0_wp * ( v(k,j+1,i) + v(k,j,i)   )                   &
+                    -  8.0_wp * ( v(k,j+2,i) + v(k,j-1,i) )                   &
+                      +         ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
+
+          diss_n(k) = - ABS( v_comp(k) - gv ) * (                             &
+                      10.0_wp * ( v(k,j+1,i) - v(k,j,i)   )                   &
+                    -  5.0_wp * ( v(k,j+2,i) - v(k,j-1,i) )                   &
+                    +           ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
+       ENDDO
+!
+!--    Now, compute vertical fluxes. Split loop into a part treating the 
+!--    lowest 2 grid points with indirect indexing, a main loop without
+!--    indirect indexing, and a loop for the uppermost 2 grip points with
+!--    indirect indexing. This allows better vectorization for the main loop.
+!--    First, compute the flux at model surface, which need has to be 
+!--    calculated explicetely for the tendency at
+!--    the first w-level. For topography wall this is done implicitely by
+!--    advc_flags_1.
+       flux_t(nzb) = 0.0_wp
+       diss_t(nzb) = 0.0_wp
+       w_comp(nzb) = 0.0_wp
+       
+       DO  k = nzb+1, nzb+2
 !
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
-          ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
-          ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
+          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
 
           k_ppp = k + 3 * ibit26
@@ -2546,6 +2612,88 @@
                                                            )
        ENDDO
-
-       DO  k = nzb+1, nzb_max
+       
+       DO  k = nzb+3, nzt-2
+
+          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
+
+          w_comp(k) = w(k,j-1,i) + w(k,j,i)
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
+                     ( 37.0_wp * ibit26 * adv_mom_5                           &
+                  +     7.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i)   + v(k,j,i)    )                &
+              -      (  8.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k+2,j,i)  + v(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( v(k+3,j,i) + v(k-2,j,i) )                   &
+                                                  )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
+                     ( 10.0_wp * ibit26 * adv_mom_5                           &
+                  +     3.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i)   - v(k,j,i)    )                &
+              -      (  5.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k+2,j,i)  - v(k-1,j,i)  )                 &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( v(k+3,j,i) - v(k-2,j,i) )                   &
+                                                           )
+       ENDDO
+       
+       DO  k = nzt-1, nzt
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          ibit26 = REAL( IBITS(advc_flags_1(k,j,i),26,1), KIND = wp )
+          ibit25 = REAL( IBITS(advc_flags_1(k,j,i),25,1), KIND = wp )
+          ibit24 = REAL( IBITS(advc_flags_1(k,j,i),24,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit26
+          k_pp  = k + 2 * ( 1 - ibit24  )
+          k_mm  = k - 2 * ibit26
+
+          w_comp(k) = w(k,j-1,i) + w(k,j,i)
+          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
+                     ( 37.0_wp * ibit26 * adv_mom_5                           &
+                  +     7.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i)   + v(k,j,i)    )                &
+              -      (  8.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k_pp,j,i)  + v(k-1,j,i)  )                &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( v(k_ppp,j,i) + v(k_mm,j,i) )                &
+                                                  )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
+                     ( 10.0_wp * ibit26 * adv_mom_5                           &
+                  +     3.0_wp * ibit25 * adv_mom_3                           &
+                  +              ibit24 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( v(k+1,j,i)   - v(k,j,i)    )                &
+              -      (  5.0_wp * ibit26 * adv_mom_5                           &
+                  +              ibit25 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( v(k_pp,j,i)  - v(k-1,j,i)  )                &
+              +      (           ibit26 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( v(k_ppp,j,i) - v(k_mm,j,i) )                &
+                                                           )
+       ENDDO
+       
+       DO  k = nzb+1, nzt
 
           flux_d    = flux_t(k-1)
@@ -2554,11 +2702,12 @@
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography. 
+!--       by a not sufficient reduction of divergences near topography.
           div = ( ( ( u_comp(k)     + gu )                                    &
                                        * ( ibit18 + ibit19 + ibit20 )         &
                   - ( u(k,j-1,i) + u(k,j,i) )                                 &
-                                       * ( IBITS(advc_flags_1(k,j,i-1),18,1)  &
-                                         + IBITS(advc_flags_1(k,j,i-1),19,1)  &
-                                         + IBITS(advc_flags_1(k,j,i-1),20,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )  &
                                          )                                    &
                   ) * ddx                                                     &
